/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplatesList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplatesList{}

// TemplatesList struct for TemplatesList
type TemplatesList struct {
	Results []Template `json:"results"`
	Total string `json:"total"`
}

// NewTemplatesList instantiates a new TemplatesList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplatesList(results []Template, total string) *TemplatesList {
	this := TemplatesList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewTemplatesListWithDefaults instantiates a new TemplatesList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplatesListWithDefaults() *TemplatesList {
	this := TemplatesList{}
	return &this
}

// GetResults returns the Results field value
func (o *TemplatesList) GetResults() []Template {
	if o == nil {
		var ret []Template
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *TemplatesList) GetResultsOk() ([]Template, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *TemplatesList) SetResults(v []Template) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *TemplatesList) GetTotal() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *TemplatesList) GetTotalOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *TemplatesList) SetTotal(v string) {
	o.Total = v
}

func (o TemplatesList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplatesList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableTemplatesList struct {
	value *TemplatesList
	isSet bool
}

func (v NullableTemplatesList) Get() *TemplatesList {
	return v.value
}

func (v *NullableTemplatesList) Set(val *TemplatesList) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplatesList) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplatesList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplatesList(val *TemplatesList) *NullableTemplatesList {
	return &NullableTemplatesList{value: val, isSet: true}
}

func (v NullableTemplatesList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplatesList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


